/***************************************************************************
 * Copyright 2001-2007 The eXo Platform SAS          All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
using System;
using System.Collections;
using Extensibility;
using System.Runtime.InteropServices;
using System.Reflection;
using Microsoft.Office.Core;
using System.IO;
using System.Windows.Forms;
using System.Threading;
using exo_jcr.webdav.csclient;
using exo_jcr.webdav.csclient.Commands;
using exo_jcr.webdav.csclient.Request;
using exo_jcr.webdav.csclient.Response;
using exo_jcr.webdav.csclient.DavProperties;

/**
 * Created by The eXo Platform SARL
 * Authors : Vitaly Guly <gavrik-vetal@ukr.net/mail.ru>
 *         : Max Shaposhnik <uy7c@yahoo.com>
 * @version $Id:
 */

namespace exo_jcr.msofficeplugin
{

	#region Read me for Add-in installation and setup information.
	// When run, the Add-in wizard prepared the registry for the Add-in.
	// At a later time, if the Add-in becomes unavailable for reasons such as:
	//   1) You moved this project to a computer other than which is was originally created on.
	//   2) You chose 'Yes' when presented with a message asking if you wish to remove the Add-in.
	//   3) Registry corruption.
	// you will need to re-register the Add-in by building the eXo.msofficeplugin project, 
	// right click the project in the Solution Explorer, then choose install.
	#endregion
    [GuidAttribute("0CEBEDF8-C8E8-4C34-B31C-567E24EFCCF8"), ProgId("exo_jcr.msofficeplugin.setup.Connect")]
	public class Connect : Object, Extensibility.IDTExtensibility2, WebDavAppContext
	{
        private CommandBarButton Open;
        private CommandBarButton RepositoryView;
        private CommandBarButton Search;
        private CommandBarButton Save;

        private CommandBarButton Settings;

        private CommandBarPopup PengYouMenu;
        public Word._Application app;
        
        private Open DialogOpen;
        private Search DialogSearch;

        private RemoteRepository RemoteRepository;

        string filename;
        string realname;

        private object applicationObject;
        private object addInInstance;

        private Thread openThread;
        private Thread closeThread;
        private Thread saveThread;

        public string Filename
        {
            set
            {
                filename = value;
            }

            get
            {
                return filename;
            }
        }

        public string RealFilename
        {
            set
            {
                realname = value;
            }
        }

		public Connect()
		{
		}

        private DavContext davContext = new DavContext("localhost", 8080, "/jcr-webdav/repository", "admin", "admin");

        public DavContext getContext()
        {
            return davContext;
        }

        public void refreshContext()
        {
            MessageBox.Show("try create new DavContext");

        }

        public void OnConnection(object application, Extensibility.ext_ConnectMode connectMode, object addInInst, ref System.Array custom) {
            applicationObject = application;
            addInInstance = addInInst;

            if (connectMode != Extensibility.ext_ConnectMode.ext_cm_Startup) {
                OnStartupComplete(ref custom);
            }
        }

        public void OnDisconnection(Extensibility.ext_DisconnectMode disconnectMode, ref System.Array custom) {
            if (disconnectMode != Extensibility.ext_DisconnectMode.ext_dm_HostShutdown)
            {
                OnBeginShutdown(ref custom);
            }
            applicationObject = null;
        }

        
        public void OnAddInsUpdate(ref System.Array custom) {
        }

        #region OnStartupComplete(ref System.Array custom)
        public void OnStartupComplete(ref System.Array custom) {
            CommandBars oCommandBars;
            CommandBar oStandardBar;

            object omissing = System.Reflection.Missing.Value;

            Console.Beep(3000, 20);
            Thread.Sleep(50);
            Console.Beep(3000, 20);

            app = (Word._Application)applicationObject;

            try
            {
                oCommandBars = (CommandBars)applicationObject.GetType().InvokeMember("CommandBars", BindingFlags.GetProperty, null, applicationObject, null);
            }
            catch (Exception)
            {
                // Outlook has the CommandBars collection on the Explorer object.
                object oActiveExplorer;
                oActiveExplorer = applicationObject.GetType().InvokeMember("ActiveExplorer", BindingFlags.GetProperty, null, applicationObject, null);
                oCommandBars = (CommandBars)oActiveExplorer.GetType().InvokeMember("CommandBars", BindingFlags.GetProperty, null, oActiveExplorer, null);
            }

            // Set up a custom button on the "Standard" commandbar.
            try
            {
                oStandardBar = oCommandBars["Menu Bar"];
            }            
            catch (Exception)
            {
                // Access names its main toolbar Database.
                oStandardBar = oCommandBars["Database"];
            }

            CommandBarControls controls = oStandardBar.Controls;

            // remove old menus...
            foreach (CommandBarControl control in controls)
            {
                String caption = control.Caption;

                if (caption.EndsWith("Documents distants") || caption.EndsWith("Remote documents"))
                {                    
                    control.Delete(null);
                }
            }

            // In case the button was not deleted, use the exiting one.
            try
            {                
                PengYouMenu = (CommandBarPopup)oStandardBar.Controls["Remote documents"];

                MessageBox.Show("PengYouMenu : " + PengYouMenu.Caption);

                Open = (CommandBarButton)PengYouMenu.Controls["Open"];
                Save = (CommandBarButton)PengYouMenu.Controls["Save"];
               // Publish = (CommandBarButton)PengYouMenu.Controls["Publier"];
               // PublishAs = (CommandBarButton)PengYouMenu.Controls["Publier sous"];
                RepositoryView = (CommandBarButton)PengYouMenu.Controls["Repository View"];
                Search = (CommandBarButton)PengYouMenu.Controls["Search"];
                Settings = (CommandBarButton)PengYouMenu.Controls["Settings"];
            
               // Publish.BeginGroup = true;
            }

            catch (Exception)
            {
                //MessageBox.Show("Adding aater exception.");
                PengYouMenu = (CommandBarPopup)oStandardBar.Controls.Add(MsoControlType.msoControlPopup, omissing, omissing, omissing, true);
                PengYouMenu.Caption = "Remote documents";
                PengYouMenu.Tag = PengYouMenu.Caption;

                Open = (CommandBarButton)PengYouMenu.Controls.Add(1, omissing, omissing, omissing, omissing);
                Open.Caption = "Open...";
                Open.Tag = Open.Caption;

                Save = (CommandBarButton)PengYouMenu.Controls.Add(1, omissing, omissing, omissing, omissing);
                Save.Caption = "Save";
                Save.Tag = Save.Caption;
                
                /*
                Publish = (CommandBarButton)PengYouMenu.Controls.Add(1, omissing, omissing, omissing, omissing);
                Publish.Caption = "Publier";
                Publish.Tag = Publish.Caption;

                PublishAs = (CommandBarButton)PengYouMenu.Controls.Add(1, omissing, omissing, omissing, omissing);
                PublishAs.Caption = "Publier sous...";
                PublishAs.Tag = PublishAs.Caption;
                //Publish.BeginGroup = true;
                */
                
                RepositoryView = (CommandBarButton)PengYouMenu.Controls.Add(1, omissing, omissing, omissing, omissing);
                RepositoryView.Caption = "Repository View";
                RepositoryView.Tag = RepositoryView.Caption;

                Search = (CommandBarButton)PengYouMenu.Controls.Add(1, omissing, omissing, omissing, omissing);
                Search.Caption = "Search...";
                Search.Tag = Search.Caption;

                Settings = (CommandBarButton)PengYouMenu.Controls.Add(1, omissing, omissing, omissing, omissing);
                Settings.Caption = "Settings...";
                Settings.Tag = Settings.Caption;
            }

            //Publish.Visible = true;
            //Publish.Click += new Microsoft.Office.Core._CommandBarButtonEvents_ClickEventHandler(this.Publish_Click);

            //PublishAs.Visible = true;
            //PublishAs.Click += new Microsoft.Office.Core._CommandBarButtonEvents_ClickEventHandler(this.PublishAs_Click);

            Open.Visible = true;
            Open.Click += new Microsoft.Office.Core._CommandBarButtonEvents_ClickEventHandler(this.Open_Click);

            Save.Visible = true;
            Save.Click += new Microsoft.Office.Core._CommandBarButtonEvents_ClickEventHandler(this.Save_Click);

            RepositoryView.Visible = true;
            RepositoryView.Click += new Microsoft.Office.Core._CommandBarButtonEvents_ClickEventHandler(this.Open_List);

            Search.Visible = true;
            Search.Click += new Microsoft.Office.Core._CommandBarButtonEvents_ClickEventHandler(this.Open_Search);

            Settings.Visible = true;
            Settings.Click += new Microsoft.Office.Core._CommandBarButtonEvents_ClickEventHandler(this.Open_Settings);


            object oName = applicationObject.GetType().InvokeMember("Name", BindingFlags.GetProperty, null, applicationObject, null);         
            oStandardBar = null;
            oCommandBars = null;


            openThread = new Thread(new ThreadStart(openThreadProc));
            openThread.Start();

            closeThread = new Thread(new ThreadStart(closeThreadProc));
            closeThread.Start();

            saveThread = new Thread(new ThreadStart(saveThreadProc));
            saveThread.Start();
        }
        #endregion

        #region OnBeginShutdown(ref System.Array custom)
        public void OnBeginShutdown(ref System.Array custom)
        {
            object omissing = System.Reflection.Missing.Value;

            Open.Delete(omissing);
            Open = null;

            PengYouMenu.Delete(omissing);
            PengYouMenu = null;

            Search.Delete(omissing);
            Settings.Delete(omissing);
            Save.Delete(omissing);
        }
        #endregion


        #region OPENING WORD DOCUMENT

        private ArrayList wordFiles = new ArrayList();

        #endregion

        #region openThreadProc
        private void openThreadProc()
        {
            while (true) {

                for (int i = 0; i < wordFiles.Count; i++)
                {
                    WordFileInfo curFileInfo = (WordFileInfo)wordFiles[i];
                    if (curFileInfo.FileAction == WordFileInfo.ACTION_OPEN) {
                        object fileName = curFileInfo.FileName;
                        object omissing = Missing.Value;
                        Word.Document doc = app.Documents.Open(ref fileName, ref omissing, ref omissing, ref omissing, ref omissing,
                                                ref omissing, ref omissing, ref omissing, ref omissing, ref omissing, ref omissing,
                                                ref omissing, ref omissing, ref omissing, ref omissing, ref omissing);

                        doc.Activate();
                        curFileInfo.WordDocument = doc;
                        curFileInfo.FileAction = WordFileInfo.ACTION_NONE;
                        curFileInfo.IsOpened = true;
                    }
                }
                Thread.Sleep(100);
            }
        }
        #endregion

        #region closeThreadProc
        private void closeThreadProc()
        {
            while (true) {
                for (int i = 0; i < wordFiles.Count; i++)
                {
                    try
                    {
                        WordFileInfo curFileInfo = (WordFileInfo)wordFiles[i];
                        if (curFileInfo.FileAction == WordFileInfo.ACTION_CLOSE)
                        {
                            curFileInfo.FileAction = WordFileInfo.ACTION_NONE;
                            Word.Document doc = curFileInfo.WordDocument;

                            object needSave = true;
                            object omissing = Missing.Value;
                            if (doc.Saved)
                            {
                                doc.Close(ref needSave, ref omissing, ref omissing);
                                wordFiles.RemoveAt(i);
                            }
                            else
                            {
                                DialogResult result = MessageBox.Show("Document has been changed. Do you want to save it?",
                                    "eXo plugin",
                                    MessageBoxButtons.YesNoCancel,
                                    MessageBoxIcon.Question);

                                if (result == DialogResult.Cancel) {
                                    curFileInfo.FileAction = WordFileInfo.ACTION_NONE;
                                } else {
                                    if (result == DialogResult.Yes) {
                                        needSave = true;
                                    } else {
                                        needSave = false;
                                    }
                                    doc.Close(ref needSave, ref omissing, ref omissing);
                                    wordFiles.RemoveAt(i);
                                }                                
                            }                            
                            break;
                        }
                    }
                    catch (Exception exc) {
                        MessageBox.Show("Unhandled exception. " + exc.Message + " AT " + exc.StackTrace);
                    }
                }
                Thread.Sleep(100);
            }
        }
        #endregion

        #region saveThreadProc
        private void saveThreadProc()
        {
            while (true) {

                for (int i = 0; i < wordFiles.Count; i++)
                {
                    try
                    {
                        WordFileInfo curFileInfo = (WordFileInfo)wordFiles[i];
                        if (curFileInfo.FileAction == WordFileInfo.ACTION_SAVE) {
                            if (curFileInfo.isChanged)
                            {
                                curFileInfo.WordDocument.Save();
                            }
                        }
                        if (curFileInfo.IsOpened)
                        {
                            if (curFileInfo.isClosed)
                            {
                                wordFiles.RemoveAt(i);                                
                                break;
                            }
                        }
                    }
                    catch (Exception exc)
                    {
                        //MessageBox.Show("Unhandled exception. " + exc.Message + " AT " + exc.StackTrace);
                    }
                }

                Thread.Sleep(100);

            }
        }
        #endregion

        #region openWordDocument(WordFileInfo fileInfo)
        public void openWordDocument(WordFileInfo fileInfo)
        {
            for (int i = 0; i < wordFiles.Count; i++)
            {
                WordFileInfo curFileInfo = (WordFileInfo)wordFiles[i];
                if (curFileInfo.RemoteFileName == fileInfo.RemoteFileName) {
                    return;
                }
            }
            fileInfo.FileAction = WordFileInfo.ACTION_OPEN;
            wordFiles.Add(fileInfo);
            //doc.MakeCompatibilityDefault();
        }
        #endregion

        public ArrayList getWordFiles()
        {
            ArrayList files = new ArrayList();
            for (int i = 0; i < wordFiles.Count; i++)
            {
                WordFileInfo curFileInfo = (WordFileInfo)wordFiles[i];
                if (curFileInfo.IsOpened)
                {
                    if (curFileInfo.isClosed)
                    {
                        //wordFiles.Remove(curFileInfo);
                    }
                    else
                    {
                        files.Add(curFileInfo);
                    }
                }
            }
            return files;
        }

        public void saveDocument(String fileName)
        {
            //Word.Document doc = (Word.Document)cashedFiles[fileName];
            //if (doc == null) {
            //    return;
            //}
            //doc.Save();
        }

        //public void closeDocument(String fileName)
        //{
        //}

        private void Open_Click(CommandBarButton cmdBarbutton, ref bool cancel) {
           DialogOpen = new Open(app, this);
           DialogOpen.ShowDialog();
        }

        private void Open_List(CommandBarButton cmdBarbutton, ref bool cancel)
        {
            if (RemoteRepository != null)
            {
                RemoteRepository.Close();
            }
            RemoteRepository = new RemoteRepository(this);
            RemoteRepository.Show();
        }

        private void Open_Search(CommandBarButton cmdBarbutton, ref bool cancel)
        {
            DialogSearch = new Search(app, this);
            DialogSearch.ShowDialog();
        }

        private void Save_Click(CommandBarButton cmdBarbutton, ref bool cancel)
        {
        }

        private void Open_Settings(CommandBarButton cmdBarbutton, ref bool cancel)
        {
            Settings DialogSettings = new Settings(app);
            DialogSettings.ShowDialog();
        }
		
	}
}