/***************************************************************************
 * Copyright 2001-2007 The eXo Platform SAS          All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
using System;
using System.IO;
using System.Collections;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Threading;
using System.Reflection;

using exo_jcr.webdav.csclient;
using exo_jcr.webdav.csclient.Commands;
using exo_jcr.webdav.csclient.Request;
using exo_jcr.webdav.csclient.Response;
using exo_jcr.webdav.csclient.DavProperties;

using System.Security.Permissions;
using Microsoft.Win32;

/**
 * Created by The eXo Platform SARL
 * Authors : Vitaly Guly <gavrik-vetal@ukr.net/mail.ru>
 *         : Max Shaposhnik <uy7c@yahoo.com>
 * @version $Id:
 */

[assembly: RegistryPermissionAttribute(SecurityAction.RequestMinimum,
    ViewAndModify = "HKEY_CURRENT_USER")]


namespace exo_jcr.msofficeplugin
{
    public partial class Open : Form
    {
        delegate void DelegateIncrementProgressBar();
        delegate void DelegateDrawFileList();
        delegate void DelegateRemoveProgressBar();
        delegate void DelegateCreateProgressBar();
        delegate void DelegateInhibControl_Off();
        delegate void DelegateInhibControl_On();

        DelegateIncrementProgressBar m_DelegateIncrementProgressBar;
        DelegateDrawFileList m_DelegateDrawFileList;
        DelegateRemoveProgressBar m_DelegateRemoveProgressBar;
        DelegateCreateProgressBar m_DelegateCreateProgressBar;
        DelegateInhibControl_Off m_DelegateInhibControl_Off;
        DelegateInhibControl_On m_DelegateInhibControl_On;

        private DavContext context;
        //
        public DavContext getContext() {
            return context;
        }

        //ArrayList directory_listing;
        SortDirection direction;
        String CurrentDir;
        int ComboIndex = 0;
        public bool getlisting;
        bool ProgressBarExists = false;

        bool getDirectoryListing_success;
        //string error_reason;

        public bool GetRemoteFile = false;
        public FileStream RemoteFile;

        Thread FillThread;
        //Thread ProgressBarThread;

        Word._Application app;
        Connect connect;

        String basedir = "";
        private String _path;


        private ArrayList path = new ArrayList();
        private Multistatus multistatus;

        public Open(object app, Connect connect)
        {
            m_DelegateIncrementProgressBar = new DelegateIncrementProgressBar(this.IncrementProgressBar);
            m_DelegateDrawFileList = new DelegateDrawFileList(this.DrawFileList);
            m_DelegateRemoveProgressBar = new DelegateRemoveProgressBar(this.RemoveProgressBar);
            m_DelegateCreateProgressBar = new DelegateCreateProgressBar(this.CreateProgressBar);
            m_DelegateInhibControl_Off = new DelegateInhibControl_Off(this.InhibControls_Off);
            m_DelegateInhibControl_On = new DelegateInhibControl_On(this.InhibControls_On);

            this.app = (Word._Application)app;
            this.connect = connect;
            InitializeComponent();
        }

        public void CreateProgressBar()
        {
            this.GetDavState = new System.Windows.Forms.ProgressBar();
            this.Controls.Add(this.GetDavState);

            this.GetDavState.Location = new System.Drawing.Point(93, 290);
            this.GetDavState.Name = "GetDavState";
            this.GetDavState.Size = new System.Drawing.Size(347, 23);
            this.GetDavState.TabIndex = 8;
            this.ProgressBarExists = true;
        }

        public String getCurrentFilePath() {
            return _path;
        }


        public void IncrementProgressBar()
        {
            this.GetDavState.Increment(1);
        }

        public void RemoveProgressBar()
        {
            if (this.ProgressBarExists == true)
                this.GetDavState.Visible = false;
        }

        private void InhibControls_On()
        {
            //this.MoreInfoButton.Enabled = false;
            this.OkButton.Enabled = false;
            this.PathListCombo.Enabled = false;
            this.FileList.Enabled = false;
            this.UpButton.Enabled = false;
        }

        private void InhibControls_Off()
        {
            //this.MoreInfoButton.Enabled = true;
            this.OkButton.Enabled = true;
            this.PathListCombo.Enabled = true;
            this.FileList.Enabled = true;
            this.UpButton.Enabled = true;
        }

        public class FillFileListThread
        {
            object open;

            public FillFileListThread(object open)
            {
                this.open = open;
            }

            public void FillThreadRun()
            {
                ((Open)open).getlisting = false;
                ((Open)open).FillFileList(((Open)open).CurrentDir);
                ((Open)open).getlisting = true;
                ((Open)open).Invoke(((Open)open).m_DelegateDrawFileList);
            }
        }
        /*
        public class IncrementProgressBarThread
        {
            object open;

            public IncrementProgressBarThread(object open)
            {
                this.open = open;
            }

            public void IncrementProgressBarThreadRun()
            {
                Thread.Sleep(500);
                if (((Open)open).getlisting == false)
                {
                    ((Open)open).Invoke(((Open)open).m_DelegateInhibControl_On);
                    ((Open)open).Invoke(((Open)open).m_DelegateCreateProgressBar);
                }
                while (((Open)open).getlisting == false)
                {
                    Thread.Sleep(500);
                    ((Open)open).Invoke(((Open)open).m_DelegateIncrementProgressBar);
                }
                ((Open)open).Invoke(((Open)open).m_DelegateRemoveProgressBar);
                ((Open)open).Invoke(((Open)open).m_DelegateInhibControl_Off);
            }
        }
        */
        private void DrawComboPwd(string pwd)
        {
            this.PathListCombo.Items.Add(pwd);
            this.PathListCombo.SelectedIndex = this.ComboIndex;
            this.ComboIndex++;
        }

        public enum SortDirection
        {
            Ascending,
            Descending
        }

        public class FileComparer : IComparer
        {
            private SortDirection m_direction = SortDirection.Ascending;

            public FileComparer() : base() { }

            public FileComparer(SortDirection direction)
            {
                this.m_direction = direction;
            }

            int IComparer.Compare(object a, object b)
            {
                Hashtable x = (Hashtable)a;
                Hashtable y = (Hashtable)b;

                if (m_direction == SortDirection.Ascending)
                {
                    if (((bool)x["is_dir"]) == true && ((bool)y["is_dir"]) == false)
                        return -1;
                    if (((bool)x["is_dir"]) == false && ((bool)y["is_dir"]) == true)
                        return 0;
                }
                else
                {
                    if (((bool)x["is_dir"]) == true && ((bool)y["is_dir"]) == false)
                        return 0;
                    if (((bool)x["is_dir"]) == false && ((bool)y["is_dir"]) == true)
                        return -1;
                }
                return (((string)x["name"]).CompareTo((string)y["name"]));
            }
        }

        private void FillFileList_LaunchThread()
        {
            try
            {
                FillFileListThread h_fill_th = new FillFileListThread(this);
                this.FillThread = new Thread(new ThreadStart(h_fill_th.FillThreadRun));
                FillThread.Start();

            } catch (Exception exc) {
                //MessageBox.Show("EEE " + exc.StackTrace);
            }

            
        }

        public String getPath()
        {
            String curPath = "/";
            for (int i = 0; i < path.Count; i++)
            {
                curPath += path[i];
                if (i < (path.Count - 1))
                {
                    curPath += "/";
                }
            }
            return curPath;
        }

        private void FillFileList(string resource)
        {
            try
            {
                String curPath = getPath();

                PropFindCommand propFind = new PropFindCommand(context);
                propFind.setResourcePath(curPath);

                propFind.addRequiredProperty(DavProperty.DISPLAYNAME);
                propFind.addRequiredProperty(DavProperty.GETCONTENTTYPE);
                propFind.addRequiredProperty(DavProperty.RESOURCETYPE);
                propFind.addRequiredProperty(DavProperty.GETLASTMODIFIED);
                propFind.addRequiredProperty(DavProperty.GETCONTENTLENGTH);
                propFind.addRequiredProperty(DavProperty.CREATIONDATE);
                propFind.addRequiredProperty(DavProperty.HREF);
                propFind.addRequiredProperty(DavProperty.SUPPORTEDLOCK);

                int status = propFind.execute();

                if (status == DavStatus.MULTISTATUS)
                {
                    this.multistatus = propFind.getMultistatus();
                    this.getDirectoryListing_success = true;
                }

                this.getDirectoryListing_success = true;
            }
            catch (Exception exc)
            {
                MessageBox.Show("Cannot load paramethers,\n please run Settings first.", "Error",
                MessageBoxButtons.OK, MessageBoxIcon.Error);
                //this.getDirectoryListing_success = true;
                this.Close();
                

            }

        }
        
        private void IncrementProgressBar_LaunchThread()
        {
            //IncrementProgressBarThread h_progress_th = new IncrementProgressBarThread(this);
            //this.ProgressBarThread = new Thread(new ThreadStart(h_progress_th.IncrementProgressBarThreadRun));
            //this.ProgressBarThread.Start();
        }
        
        private void LaunchErrorWindow()
        {
            //string caption = "Connection error";
            //MessageBoxButtons buttons = MessageBoxButtons.OK;
            //DialogResult result;

            //result = MessageBox.Show(this, this.error_reason, caption, buttons);
            //if (result == DialogResult.OK)
            //{
            //    this.ProgressBarThread.Abort();
            //    this.FillThread.Abort();
            //    this.Close();
            //}
        }

        private void DrawFileList()
        {
            if (getDirectoryListing_success == false)
                LaunchErrorWindow();
            this.FileList.Items.Clear();
          
                ArrayList resplist = multistatus.getResponses();


                for (int i = 0; i < resplist.Count; i++)
                {
                    int image = 2;

                    exo_jcr.webdav.csclient.Response.DavResponse response = (exo_jcr.webdav.csclient.Response.DavResponse)resplist[i];

                    String href = response.getHref().getHref();
                    if (href == null)
                    {
                        href = "";
                    }

                  

                    String displayName = "";
                    WebDavProperty displayNameProp = response.getProperty(DavProperty.DISPLAYNAME);
                    if (displayNameProp != null)
                    {
                        displayName = ((DisplayNameProperty)displayNameProp).getDisplayName();
                    }

                    ResourceTypeProperty resourceTypeProp = (ResourceTypeProperty)response.getProperty(DavProperty.RESOURCETYPE);
                    if (resourceTypeProp.getResourceType() == ResourceTypeProperty.COLLECTION)
                        image = 2;
                    else
                        image = 3;

                    String cdate = "";
                    CreationDateProperty cdpropProp = (CreationDateProperty)response.getProperty(DavProperty.CREATIONDATE);
                    if (cdpropProp != null)
                    {
                        cdate = ((CreationDateProperty)cdpropProp).getCreationDate();
                    }                         


                    String lastmodified = "";
                    LastModifiedProperty lastModifiedProp = (LastModifiedProperty)response.getProperty(DavProperty.GETLASTMODIFIED);
                        if (lastModifiedProp != null)
                        {
                            lastmodified = ((LastModifiedProperty)lastModifiedProp).getLastModified();
                        }                         


                    String clenght = "";// response.getProperty(DavProperty.GETCONTENTLENGTH).ToString();
                    if (clenght == null)
                    {
                        clenght = "";
                    }

                    System.Windows.Forms.ListViewItem Line = new System.Windows.Forms.ListViewItem(new string[] {
                    displayName,
                    href,
                    cdate,   
                    lastmodified,
                    clenght,
                    }, image);

                    this.FileList.Items.Add(Line);
                }
            
        }

        private void CancelButton_Click(object sender, EventArgs e)
        {
            
                //this.ProgressBarThread.Abort();
                this.FillThread.Abort();
                this.Close();
            
        }

        private void UpButton_MouseEnter(object sender, EventArgs e)
        {
            this.UpButton.FlatStyle = System.Windows.Forms.FlatStyle.Popup;
        }

        private void UpButton_MouseLeave(object sender, EventArgs e)
        {
            this.UpButton.FlatStyle = System.Windows.Forms.FlatStyle.Flat;
        }

        private void FileList_ColumnClick(object sender, ColumnClickEventArgs e)
        {
            if (this.direction == SortDirection.Ascending)
                this.direction = SortDirection.Descending;
            else
                this.direction = SortDirection.Ascending;
            DrawFileList();
        }

        #region FileList_MouseDoubleClick
        private void FileList_MouseDoubleClick(object sender, MouseEventArgs e)
        {
            int item_index = ((ListView)sender).FocusedItem.Index;

            ArrayList resplist = multistatus.getResponses();
            exo_jcr.webdav.csclient.Response.DavResponse response = (exo_jcr.webdav.csclient.Response.DavResponse)resplist[item_index];

            ResourceTypeProperty rtproperty = (ResourceTypeProperty)response.getProperty(DavProperty.RESOURCETYPE);
            if (rtproperty.getResourceType() == ResourceTypeProperty.RESOURCE)
            {

                this._path = response.getHref().getHref();
                OpenWordDocument(_path);

            }
            else
            {
                String _href = response.getHref().getHref();
                this.context = createContext(_href);

                DrawComboPwd(basedir);
                this.CurrentDir = basedir;
                FillFileList_LaunchThread();
                IncrementProgressBar_LaunchThread();

            }
        }
        #endregion

        #region OpenWordDocument
        private void OpenWordDocument(string resource)
        {
            Environment.SpecialFolder p = Environment.SpecialFolder.Personal;
            String s_p = Environment.GetFolderPath(p);
            String f_name = resource.Substring(resource.LastIndexOf("/")+1);
            String FILE_NAME = s_p + "\\" + f_name;

            String curPath = getPath();
            this.context = createContext(resource);
            GetCommand get = new GetCommand(context);
            get.setResourcePath(curPath);
            int status = get.execute();
            if (status == DavStatus.OK)
            {

                byte[] resp = get.getResponseBody();

                if (!File.Exists(FILE_NAME))
                {

                    FileStream fs = new FileStream(FILE_NAME, FileMode.CreateNew, FileAccess.Write, FileShare.Read);
                    BinaryWriter w = new BinaryWriter(fs);
                    for (long i = 0; i < resp.Length; i++)
                    {
                        w.Write(resp[i]);
                    }
                    w.Close();
                    fs.Close();



                }

            }
            
            //connect.Filename = FILE_NAME;
            //connect.openWordDocument(FILE_NAME);
            this.Close();
        }
        #endregion

        private void UpButton_MouseClick(object sender, MouseEventArgs e)
        {
            this.CurrentDir = this.CurrentDir.Remove(this.CurrentDir.LastIndexOf("/"));
            this.context = createContext(this.CurrentDir);
            DrawComboPwd(this.CurrentDir);
            FillFileList_LaunchThread();
            IncrementProgressBar_LaunchThread();
        }

        private void PathListCombo_SelectionChangeCommitted(object sender, EventArgs e)
        {
            string ItemMsg;

            ItemMsg = ((ComboBox)sender).SelectedItem.ToString();
            if (ItemMsg.CompareTo(this.CurrentDir) != 0)
            {
                this.CurrentDir = ItemMsg;
                FillFileList_LaunchThread();
                //IncrementProgressBar_LaunchThread();
            }
        }

        private void Open_Load(object sender, EventArgs e)
        {
            this.context = createContext("");
            DrawComboPwd(basedir);
            this.CurrentDir = basedir;
            FillFileList_LaunchThread();
//            IncrementProgressBar_LaunchThread();
        }

        private void Open_FormClosing(object sender, FormClosingEventArgs e)
        {
            //this.ProgressBarThread.Abort();
            this.FillThread.Abort();
        }
        /*
        private void MoreInfoButton_Click(object sender, EventArgs e)
        {
            OpenMoreInfos MoreInfosWindows = new OpenMoreInfos();
            MoreInfosWindows.ShowDialog();
        }
        */

        

        private void PathListCombo_SelectedIndexChanged(object sender, EventArgs e)
        {
            //this.CurrentDir = this.CurrentDir.Remove(this.CurrentDir.LastIndexOf("/"));
            //this.CurrentDir = PathListCombo.Text;
            //if (!PathListCombo.Text.Equals(""))
            //{
            //    this.context = createContext(this.CurrentDir);
            //    DrawComboPwd(this.CurrentDir);
            //    FillFileList_LaunchThread();
            //}
            //IncrementProgressBar_LaunchThread();


        }

        private DavContext createContext(String url)
        {
            RegistryKey soft_key = Registry.CurrentUser.OpenSubKey(RegKeys.SOFTWARE_KEY);
            try
            {

                RegistryKey exo_key = soft_key.OpenSubKey(RegKeys.EXO_KEY);
                RegistryKey client_key = exo_key.OpenSubKey(RegKeys.CLIENT_KEY);

                String _server = client_key.GetValue(RegKeys.S_ADDDR_KEY, "").ToString();
                int _port = System.Convert.ToInt32(client_key.GetValue(RegKeys.S_PORT_KEY, "").ToString());
                String _servlet = client_key.GetValue(RegKeys.S_SERVLET_KEY, "").ToString();
                String _username = client_key.GetValue(RegKeys.USER_KEY, "").ToString();
                String svalue = client_key.GetValue(RegKeys.PASS_KEY, "").ToString();
                byte[] bs_pass = System.Convert.FromBase64String(svalue);
                String _pass = Encoding.UTF8.GetString(bs_pass);
                String servletPath = "";
                String to_find = _server + ":" + _port;

                if (!url.Equals(""))
                {
                    servletPath = url.Substring(url.IndexOf(to_find) + to_find.Length);

                }

                if (servletPath.Equals(_servlet))
                    this.UpButton.Hide();
                else
                    this.UpButton.Show();

                if (servletPath != "")
                {
                    this.basedir = "http://" + _server + ":" + _port + servletPath;
                    return new DavContext(_server, _port, servletPath, _username, _pass);

                }
                else
                {

                    this.UpButton.Hide();
                    this.basedir = "http://" + _server + ":" + _port + _servlet;
                    return new DavContext(_server, _port, _servlet, _username, _pass);
                }



            }
            catch (Exception regexc)
            {
                //MessageBox.Show(regexc.StackTrace);
                return null;

            }
        }

    }
}