/***************************************************************************
 * Copyright 2001-2007 The eXo Platform SAS          All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
using System;
using System.Collections.Generic;
using System.Collections;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Text;
using System.Windows.Forms;

using exo_jcr.webdav.csclient.Response;
using exo_jcr.webdav.csclient.DavProperties;
using exo_jcr.webdav.csclient;

/**
 * Created by The eXo Platform SARL
 * Authors : Vitaly Guly <gavrik-vetal@ukr.net/mail.ru>
 *         : Max Shaposhnik <uy7c@yahoo.com>
 * @version $Id:
 */

namespace exo_jcr.msofficeplugin
{
    public partial class PropertyUpdateControl : UserControl
    {
        private ActiveAppContext activeAppContext;
        
        public PropertyUpdateControl()
        {
            InitializeComponent();
        }

        public void setAppContext(ActiveAppContext activeAppContext)
        {
            this.activeAppContext = activeAppContext;
        }

        public void clearItems()
        {
            listProps.Items.Clear();
        }

        public void fillPropsList(Multistatus multistatus)
        {
            try
            {
                ArrayList responses = multistatus.getResponses();
                for (int i = 0; i < responses.Count; i++)
                {
                    DavResponse response = (DavResponse)responses[i];
                    ArrayList props = response.getProperties();
                    for (int k = 1; k < props.Count; k++)
                    {
                        WebDavProperty curProperty = (WebDavProperty)props[k];

                        ListViewItem viewItem = new ListViewItem(new string[] {
                            curProperty.getPropertyName(),
                            curProperty.getTextContent()
                            });
                        
                        listProps.Items.Add(viewItem);
                        listProps.Sorting = SortOrder.Ascending;
                        listProps.Sort();
                        
                    }

                }

            }
            catch (Exception ee) {

                MessageBox.Show("AT fillPropsList"+ee.Message+ee.StackTrace);
            }




        
        }

        private void btn_refresh_Click(object sender, EventArgs e)
        {
            activeAppContext.doRefreshPropertyList();
        }





    }
}
